require "config"
require "extern"
require "util"

$trustlist = $conf["trust"]
#$apollo    = $conf[command["apollo"]]

module Signature
  module_function
  #
  # make sigunature
  #
  def generate(keygen, str)
    Util.printtrace(keygen, str) ## debug
=begin
    open2($IN, $OUT, $apollo, "-g");
    print $OUT "$keygen\n";
    close $OUT;
    my $pubkey = <$IN>;
    my $prikey = <$IN>;
    close $IN;
    wait;
    chomp($pubkey, $prikey);
  
    my $md5 = Shingetsu::Extern::md5digest($str);
    open2($IN, $OUT, $apollo, "-s");
    print $OUT "$md5\n$pubkey\n$prikey\n";
    close $OUT;
    my $sign = <$IN>;
    close $IN;
    wait;
    chomp($sign);
    return ($pubkey, $sign);
=end
  end
  
  #
  # check sigunature
  #
  def check(rec)
    return true
=begin
    my($str, $t) = ("", "");
    foreach $t (split /,/, $rec{target}) {
      $str .= "<>$t:$rec{$t}";
    }
    $str =~ s/^<>//;
    my $md5 = Shingetsu::Extern::md5digest($str);
    open2($IN, $OUT, $apollo, "-v");
    print $OUT "$md5\n$rec{sign}\n$rec{pubkey}\n";
    close $OUT;
    my $flag = <$IN>;
    close $IN;
    wait;
    chomp($flag);
    return ($flag eq "True");
=end
  end
  
  #
  # make public key readable string
  #
  def pubkey2trip(pubkey)
    Util.printtrace(pubkey) ## debug

    if defined?(Extern.pubkey2trip) then
      return Extern.pubkey2trip(pubkey)
    end
=begin
    if (defined &Shingetsu::Extern::pubkey2trip) {
      return Shingetsu::Extern::pubkey2trip($pubkey)
    } else {
      open2($IN, $OUT, $apollo, "-c");
      print $OUT "$pubkey\n";
      close $OUT;
      my $trip = <$IN>;
      close $IN;
      wait;
      chomp($trip);
      return $trip;
    }
=end
  end
  
  #
  # add trip to trust list
  #
  def addlist(trip)
    unless include(trip) then
      Util.lock()
      File.open($trustlist, "a") {|f|
        f << trip << "\n";
      }
    end
  rescue Errno::ENOENT, Errno::EACCES
    raise "#{$trustlist}: open failed. #{$!}"
  end
  
  #
  # remove trip from list
  #
  def dellist(trip)
    Util.printtrace(trip) ## debug

    trip += "\n"
    if FileTest.exist?($trustlist) then
      trips = IO.readlines($trustlist)
    else
      return
    end
    if trips.include?(trip) then
      Util.lock()
      begin
        File.open($trustlist, "w") {|f|
          trips.each {|x|
            f << x if x != trip
          }
        }
      rescue Errno::ENOENT, Errno::EACCES
        raise "#{$trustlist}: open failed. #{$!}"
      ensure
        Util.unlock()
      end
    end
  end

  #
  # include trip
  #
  def include(trip)
    Util.printtrace(trip) ## debug

    trips = list()
    if trips.grep(trip) then
      return 1
    else
      return nil
    end
  end

  #
  # show all trip
  #
  def list()
    Util.printtrace(list) ## debug

    trips = IO.readlines($trustlist)
    trips.collect! {|x| x.chomp}
    return trips
  end
end
